;
;	MSX SOKO Ver.1.12
;
	.Z80
;
	ASEG
;
;PORT
_PORTVDP EQU	98H
;
;BIOS
RDVRM	EQU	004AH	; HL=VRAM ADDR, A=DATA(RET)
WRTVRM	EQU	004DH	; HL=VRAM ADDR, A=DATA
SETRD	EQU	0050H	; HL=VRAM ADDR
SETWRT	EQU	0053H	; HL=VRAM ADDR
FILVRM	EQU	0056H	; HL=VRAM ADDR, BC=SIZE, A=DATA
LDIRMV	EQU	0059H	; HL=VRAM ADDR, DE=MEM ADDR, BC=SIZE
LDIRVM	EQU	005CH	; HL=VRAM ADDR, DE=MEM ADDR, BC=SIZE
BEEP	EQU	00C0H	;
CLS	EQU	00C3H	;
;
; VRAM
_PATGEN	EQU	0000H	; 0000H-17FFH PATTERN GANERATOR
_SPATTR	EQU	1B00H	; 1B00H-1B7FH SPRITE ATTRIBUTE
_COLOR	EQU	2000H	; 2000H-37FFH COLOR
_SPGENE	EQU	3800H	; 3800H-3FFFH SPRITE GANERATOR
;
; USR()
_PARAM	EQU	0F7F8H
;
; FONT
_FONT	EQU	0F920H
;
	ORG	85F8H
;
;	work area
;
_SPEED:	DS	1	; 1:slow-9:fast
_BOYXY:	DS	2	; BOY_X*8, BOY_Y
_PTNUM:	DS	1
_PTADR:	DS	2
_PTBITP:DS	1
_BACK:	DS	1	; BCD 4bit*2, bit3:with CARGO, bit1-0:DIR, 0FH:NO DATA
;
	ORG	8600H
;
;	set sprite data
;	USR1(0)
;
USR1:	LD	HL, _SPLDATA	; (_SPGENE.._SPGENE+5FH)=(_SPLDATA.._SPLDATA+5FH)
	LD	DE, _SPGENE
	LD	BC, 0060H
	JP	LDIRVM
;
;	clear screen
;	USR2(0)
;
USR2:	LD	HL, _SPATTR	; (_SPATTR),(_SPATTR+4),(_SPATTR+8)=0D1H
	LD	DE, 0004H
	LD	A, 0D1H
	LD	B, 03H
L001:	CALL	WRTVRM
	ADD	HL, DE
	DJNZ	L001		; LOOP NEXT
	JP	CLS
;
;	write screen
;	USR3(ScreenNo)
;
USR3:	LD	HL, _BACK	; BACK DATA CLR
	LD	(HL), 0FFH
	LD	BC, SCRIDX	; HL=SCRIDX+(SCRIDX+ScreenNo*2)
	LD	HL, (_PARAM)
	ADD	HL, HL
	ADD	HL, BC
	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	EX	DE, HL
	ADD	HL, BC
	LD	B, (HL)		; B=(HL++)=WALL(N)
	INC	HL
	LD	C, (HL)		; C=(HL++)=CARGO(N)
	INC	HL
;
	XOR	A		; BITP(A')=0
	EX	AF, AF'
	CALL	XYGET		; (SP)=ADDR, A'=BITP, L=X*8, H=Y
	LD	(_BOYXY), HL	; SAVE BOYXY
	POP	HL		; RESTORE ADDR(HL)
;
	CALL	DATA5GET	; A=DATA
	LD	D, A		; WALL_Y=A
	LD	E, 00H		; WALL_X=0
L002:	PUSH	DE		; SAVE WALLXY(DE)
	CALL	DATA5GET	; A=DATA*8
	ADD	A, A
	ADD	A, A
	ADD	A, A
	EX	(SP), HL	; SAVE ADDR(HL) AND RESTORE WALLXY(HL)
	CP	L		; IF A<WALL_X
	JR	NC, L003
	INC	H		; WALL_Y++
L003:	LD	L, A		; WALL_X=A
	PUSH	HL		; SAVE WALLXY(HL)
	CALL	DSPWALL		; DSP WALL
	POP	DE		; RESTORE WALLXY(DE)
	POP	HL		; RESTORE ADDR(HL)
	DJNZ	L002		; LOOP NEXT
;
	EX	AF, AF'		; IF BITP(A')=9 HL++
	CP	09H
	JR	NZ, L004
	INC	HL
L004:	EX	AF, AF'
	LD	B, C		; B=CARGO(N)
L005:	CALL	XYGET		; (SP)=ADDR, A'=BITP, L=X*8, H=Y
	CALL	DSPCARGO	; DSP CARGO
	POP	HL		; RESTORE ADDR(HL)
	DJNZ	L005		; LOOP NEXT
;
	LD	A, C		; (_PTNUM)=CARGO(N)
	LD	(_PTNUM), A
	LD	(_PTADR), HL	; (_PTADR)=ADDR(HL)
	EX	AF, AF'		; (_PTBITP)=BITP(A')
	LD	(_PTBITP), A
	CALL	DSPALLPT2	; DSP ALL POINT(register)
;
	LD	A, 01H		; DSP BOY(RIGHT)
	JP	DSPBOY
;
;	move boy & judgment
;	N(CLEAR=0) = USR4(Stick)
;
USR4:	LD	HL, _PARAM	; A=Stick(1:U,3:R,5:D,7:L)
	LD	A, (HL)
	LD	(HL), 0FFH	; RET=0FFH
	SRL	A		; A=A>>1=DIR(0:U,1:R,2:D,3:L)
	RET	NC		; IF NOT DIR RETURN
;
	PUSH	AF		; SAVE DIR
	CALL	MOVCALC		; HL=BOYXY, DE=OFFSET
	ADD	HL, DE		; HL=BOYXY+OFFSET
	CALL	RDVRM		; (BOYXY+OFFSET) PATTERN
	LD	B, 00H		; B=00H(without CARGO)
	OR	A		; BRANK CHECK
	JR	Z, MOVBOY	; YES..MOVE BOY
	LD	BC, (_GRPCARGO)	; CARGO CHECK
	XOR	C
	JR	NZ, MOVDIR	; NO..DONT MOVE
	ADD	HL, DE		; HL=BOYXY+OFFSET*2
	CALL	RDVRM		; (BOYXY+OFFSET*2) PATTERN
	OR	A		; BRANK CHECK
	JR	NZ, MOVDIR	; NO..DONT MOVE
;
MOVCARGO:			; MOVE BOY WITH CARGO
	PUSH	HL		; SAVE HL=BOYXY+OFFSET*2
	SBC	HL, DE		; HL=HL-OFFSET
	PUSH	HL		; SAVE HL=BOYXY+OFFSET
	CALL	DSPCLR		; DSP CLEAR
	POP	HL		; RESTORE HL=BOYXY+OFFSET
	EX	(SP), HL	; (SP)=BOYXY+OFFSET, HL=BOYXY+OFFSET*2
	CALL	DSPCARGO	; DSP CARGO
	CALL	DSPALLPT	; DSP ALL POINT
	LD	HL, _PARAM	; RET N(CLEAR=0)
	LD	(HL), C
	LD	B, 08H		; B=08H(with CARGO)
	POP	HL		; RESTORE HL=BOYXY+OFFSET
;
MOVBOY:				; MOVE BOY
	LD	(_BOYXY), HL	; SAVE BOYXY
	POP	AF		; A=DIR
	PUSH	AF
	OR	B		; (with CARGO)
	LD	HL, _BACK	; BACK DATA PUSH
	RRD	
	JR	MOVDIR
;
;	step back
;	USR5(0)
;
USR5:	LD	HL, _BACK	; BACK DATA POP
	LD	A, 0FH
	RLD	
	CP	0FH		; NO BACK DATA?
	JR	Z, MOVWAIT
;
	LD	B, A		; B=BACK DATA
	AND	03H		; A=BACK DATA(DIR MASK)
	PUSH	AF		; SAVE DIR
	CALL	MOVCALC		; HL=BOYXY, DE=XY OFFSET
	SBC	HL, DE		; BOYXY=BOYXY-OFFSET
	LD	(_BOYXY), HL	; SAVE BOYXY
	BIT	3, B		; WITH CARGO?
	JR	Z, MOVDIR	; NO
;
	ADD	HL, DE		; HL=BOYXY+OFFSET
	PUSH	HL		; SAVE HL=BOYXY+OFFSET
	ADD	HL, DE		; HL=BOYXY+OFFSET*2
	CALL	DSPCLR		; DSP CLEAR
	POP	HL		; RESTORE HL=BOYXY+OFFSET
	CALL	DSPCARGO	; DSP CARGO
	CALL	DSPALLPT	; DSP ALL POINT
;
MOVDIR:	POP	AF		; RESTORE DIR
	CALL	DSPBOY		; DSPBOY
MOVWAIT:LD	HL, _SPEED	; MOVE WAIT
	LD	A, 10		; A=10-(_SPEED)
	SUB	(HL)
	RET	C		; LOOP A TIMES
MOV002:	RET	Z
	EX	AF, AF'
	CALL	BEEP
	EX	AF, AF'
	DEC	A
	JR	MOV002
;
;	set speed
;	USR6(Speed)
;
USR6:	LD	A, (_PARAM)	; A=Speed
	LD	(_SPEED), A	; (_SPEED)=A
	RET
;
;	subroutines
;
MOVCALC:			; MOVE OFFSET CALC
				; INPUT A=DIR(0:U,1:R,2:D,3:L)
				; RET HL=BOYXY, DE=XY OFFSET
	LD	HL, _MOVOFF	; DE=(_MOVOFF+DIR*2)
	ADD	A, A
	LD	E, A
	LD	D, 00H
	ADD	HL, DE
	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	LD	HL, (_BOYXY)	; HL=(_BOYXY)
	RET
;
DSPBOY:				; DSP BOY
				; INPUT A=DIR(0:U,1:R,2:D,3:L)
	EX	AF, AF'		; SAVE DIR
	LD	HL, _SPATTR
	CALL	SETWRT
	LD	DE, (_BOYXY)	; DE=(_BOYXY)
	LD	A, D		; D=D*8-1
	ADD	A, A
	ADD	A, A
	ADD	A, A
	DEC	A
	LD	D, A
	EX	AF, AF'		; RESTORE DIR
	LD	HL, _PALDATA
				; B=3(LOOP), C=_PORTVDP
	LD	BC, 0300H + _PORTVDP
DSP001:	OUT	(C), D		; Y-1(255,7,15..)
	EX	(SP), HL	;   WAIT(19state)
	OUT	(C), E		; X(0,8,16,...)
	EX	(SP), HL	;   WAIT(19state)
	OUT	(C), A		; SPRITE No
	ADD	A, 04H		;   (7state)
	NOP			;   WAIT(4state)
	OUTI			; PALETTE
	JR	NZ, DSP001	;   (12state)
	RET
;
DSPCLR:				; DSP CLEAR
	XOR	A		; PATTERN=00H
	CALL	DSP002
	SET	5, H		; HL=HL+COLOR(COLOR VRAM ADDR)
	LD	A, 11H		; FCOLOR=BCOLOR=BLACK
DSP002:	LD	BC, 0008H	; VRAM(HL..HL+7)=A
	JP	FILVRM
;
DSPWALL:			; DSP WALL
	LD	DE, _GRPWALL
	JR	DSPDATA
;
DSPCARGO:			; DSP CARGO
	LD	DE, _GRPCARGO
;
DSPDATA:			; DSP PATTERN & COLOR
	CALL	DSP8BYTE
DSPCOLOR:			; DSP COLOR
	SET	5, H		; HL=HL+COLOR(COLOR VRAM ADDR)
DSP8BYTE:			; VRAM(HL..HL+7)=(DE..DE+7)
	CALL	SETWRT
	PUSH	BC
	LD	B, 8		; LOOP 8 TIMES
DSP004:	LD	A, (DE)
	INC	DE
	OUT	(_PORTVDP), A
	DJNZ	DSP004		; LOOP NEXT
	POP	BC
	RET
;
DSPALLPT:			; DSP ALL POINT
				; RET C=N(CLEAR=0)
	LD	A, (_PTNUM)	; C=(_PTNUM)
	LD	C, A
	LD	HL, (_PTADR)	; ADDR(HL)=(_PTADR)
	LD	A, (_PTBITP)	; BITP(A')=(_PTBITP)
DSPALLPT2:			; DSP ALL POINT(register)
	EX	AF, AF'
	LD	B, C		; B=C
DSP005:	CALL	XYGET		; (SP)=ADDR, A'=BITP, L=X*8, H=Y
	CALL	DSPPOINT	; DSP POINT
	POP	HL		; RESTORE ADDR(HL)
	DJNZ	DSP005		; LOOP NEXT
	RET
;
DSPPOINT:			; DSP POINT
				; INPUT L=X*8, H=Y, C=N
				; RET C=N(CLEAR=N-1)
	CALL	RDVRM		; CARGO CHECK
	LD	DE, _GRPCARGO
	EX	DE, HL
	CP	(HL)
	EX	DE, HL
	JR	Z, DSPCARPT	; YES
DSPDOT:				; DSP DOT
	LD	DE, _GRPDOT
	SET	2, L		; HL=HL+4
	CALL	DSP006
	SET	5, H		; HL=HL+COLOR(COLOR VRAM ADDR)
DSP006:	LD	A, (DE)		; VRAM(HL)=(DE)
	INC	DE
	JP	WRTVRM
DSPCARPT:			; DSP POINT with CARGO
	DEC	C		; C--
	LD	DE, _GRPCARPT	; CHANGE CARGO COLOR
	JR	DSPCOLOR
;
; BITP HL E        D
; 0->6 +1 xxxxxyyy yy......
; 6->4 +1 ..xxxxxy yyyy....
; 4->2 +1 ....xxxx xyyyyy..
; 2->0 +2 ......xx xxxyyyyy
; RET     L        H
;         xxxxx... ...yyyyy
;
XYGET:				; XY GET
				; INPUT HL=ADDR, A'=BITP
				; RET (SP)=ADDR, A'=BITP, L=X*8, H=Y
	LD	E, (HL)		; E=(HL++),D=(HL++)
	INC	HL
	LD	D, (HL)
	INC	HL
	EX	AF, AF'		; BITP(A)=(BITP(A')-10)&06H
	SUB	10
	AND	06H
	JR	Z, XY002	; IF BITP!=0
	DEC	HL		;   HL--
	PUSH	AF
XY001:	SRL	E		;   ED=ED>>BITP
	RR	D
	DEC	A
	JR	NZ, XY001
	POP	AF		; ENDIF
XY002:	EX	AF, AF'
	EX	(SP), HL	; (SP)=HL
	PUSH	HL
	LD	A, D		; H=D&1FH
	AND	1FH
	LD	H, A
	LD	A, D		; L=(ED>>2)&0F8H
	SRL	E
	RRA
	SRL	E
	RRA
	AND	0F8H
	LD	L, A
	RET
;
; BITP   HL E        A
;  8->11    xxxxx... ........
;  7->10    .xxxxx.. ........
;  6-> 9    ..xxxxx. ........
;  5-> 8 +1 ...xxxxx ........
;  4-> 7 +1 ....xxxx x.......
; 11-> 6 +1 .....xxx xx......
; 10-> 5 +1 ......xx xxx.....
;  9-> 4 +1 .......x xxxx....
; RET                A
;                    ...xxxxx
;
DATA5GET:			; 5BIT DATA GET
				; INPUT HL=ADDR, A'=BITP
				; RET HL=ADDR, A'=BITP, A=DATA5
	LD	E, (HL)		; E=(HL++),A=(HL)
	INC	HL
	LD	A, (HL)
	EX	AF, AF'		; SAVE A, BITP(A)=(BITP(A')-5)&07H
	SUB	5
	AND	07H
	JR	Z, XY003
	CP	4
	JR	NC, XY004
	DEC	HL		; IF BITP=3..1 HL--
XY003:	ADD	A, 8		; IF BITP<4 BITP=BITP+8
XY004:	LD	D, A		; D=BITP
	EX	AF, AF'		; BITP(A')=BITP(A), RESTORE A 
XY005:	SRL	E		; D=EA>>BITP
	RRA
	DEC	D
	JR	NZ, XY005
	AND	1FH
	RET
;
;	print letters
;	USR("'@'+color"+"'@'+x"+"'@'+y"+String)
;
USR:	LD	HL, (_PARAM)
	LD	B, 00H		; B=0
	LD	C, (HL)		; C=STRING LENGTH
	LD	(HL), B		; PARAM[0]=0
	INC	HL
	LD	E, (HL)		; DE=STRING ADDR
	INC	HL
	LD	D, (HL)
	LD	A, (DE)		; AH=(STRING[0]-40H)=FCOLOR
	INC	DE		; n++
	DEC	C		; len--
	ADD	A, A
	ADD	A, A
	ADD	A, A
	ADD	A, A
	INC	A		; AL=01H=BCOLOR
	EX	AF, AF'		; SAVE A=COLOR
				; HL=PATTERN VRAM ADDR
	LD	A, (DE)		; L=((STRING[1]-40H)=X)*8
	INC	DE		; n++
	DEC	C		; len--
	ADD	A, A
	ADD	A, A
	ADD	A, A
	LD	L, A
	LD	A, (DE)		; H=(STRING[2]-40H)=Y
	INC	DE		; n++
	DEC	C		; len--
	AND	1FH
	LD	H, A
;
	CALL	SETWRT
	PUSH	HL		; SAVE HL=PATTERN VRAM ADDR
	PUSH	BC		; SAVE B=0, C=STRING LENGTH
	LD	A, C		; A=STRING LENGTH
				; LOOP A TIMES
L007:	EX	DE, HL		; HL=(_FONT)+STRING[n++]*8
	LD	E, (HL)
	EX	DE, HL
	INC	DE
	LD	H, B
	ADD	HL, HL
	ADD	HL, HL
	ADD	HL, HL
	LD	BC, (_FONT)
	ADD	HL, BC
				; B=8(LOOP), C=_PORTVDP
	LD	BC, 0800H + _PORTVDP
L008:	OUTI			; OUTPUT FONT PATTERN
	JR	NZ, L008	; LOOP NEXT
	DEC	A		; len--
	JR	NZ, L007
;
	POP	HL		; RESTORE H=0, L=STRING LENGTH
	ADD	HL, HL		; HL=HL*8
	ADD	HL, HL
	ADD	HL, HL
	EX	(SP), HL	; BC=HL, RESTORE HL=PATTERN VRAM ADDR
	POP	BC
	SET	5, H		; HL=HL+2000H(COLOR VRAM ADDR)
	EX	AF, AF'		; RESTORE A=COLOR
	JP	FILVRM
;
;	move offset
;
_MOVOFF:DW	0FF00H,0008H,0100H,0FFF8H
;
;	graphic data
;
;	ԍ	F		ԋPx	Px	΋Px
;@	0			0	0	0
;A	1			0	0	0
;B	2			1	1	6
;C	3	邢	3	3	7
;D	4	Â		1	7	1
;E	5	邢	2	7	3
;F	6	Â		5	1	1
;G	7	VA		2	7	6
;H	8			7	1	1
;I	9	邢	7	3	3
;J	10	Â		6	1	6
;K	11	邢	6	3	6
;L	12	Â		1	1	4
;M	13	}[^	6	5	2
;N	14	D		5	5	5
;O	15			7	7	7
;
_GRPWALL:
	DB	0E7H,0E7H,007H,0E7H,0E7H,0E0H,0E7H,0E7H	; PATTERN
	DB	084H,084H,084H,084H,084H,084H,084H,084H	; COLOR
_GRPCARGO:
	DB	07EH,0E7H,0E7H,0E7H,000H,0E7H,0E7H,07EH	; PATTERN
	DB	071H,07DH,07DH,07DH,00DH,07DH,07DH,071H	; COLOR
_GRPCARPT:
	DB	0A1H,0A7H,0A7H,0A7H,007H,0A7H,0A7H,0A1H	; COLOR
_GRPDOT:
	DB	018H					; PATTERN
	DB	081H					; FCOLOR=RED,BCOLOR=BLACK
;
;	sprite data
;
_PALDATA:
	DB	00AH					; (color1)
	DB	007H					; (color2)
	DB	008H					; (color3)
_SPLDATA:
	DB	081H,000H,000H,000H,000H,03CH,066H,0C3H	; U(color1)
	DB	000H,018H,010H,000H,000H,038H,06CH,0C6H	; R(color1)
	DB	0C3H,066H,03CH,000H,000H,000H,000H,081H	; D(color1)
	DB	000H,018H,008H,000H,000H,01CH,036H,063H	; L(color1)
	DB	000H,081H,081H,07EH,03CH,000H,000H,000H	; U(color2)
	DB	000H,000H,000H,03FH,038H,000H,000H,000H	; R(color2)
	DB	000H,000H,000H,03CH,07EH,081H,081H,000H	; D(color2)
	DB	000H,000H,000H,0FCH,01CH,000H,000H,000H	; L(color2)
	DB	018H,03CH,018H,000H,000H,000H,000H,000H	; U(color3)
	DB	038H,020H,021H,000H,000H,000H,000H,000H	; R(color3)
	DB	000H,000H,000H,000H,000H,018H,03CH,018H	; D(color3)
	DB	01CH,004H,084H,000H,000H,000H,000H,000H	; L(color3)
;
;	SOKO data
;
	ORG	8900H
SCRIDX:
	END
